Index: ntoskrnl/mm/section.c
===================================================================
RCS file: /CVS/ReactOS/reactos/ntoskrnl/mm/section.c,v
retrieving revision 1.162
diff -u -r1.162 section.c
--- ntoskrnl/mm/section.c	28 Aug 2004 22:18:24 -0000	1.162
+++ ntoskrnl/mm/section.c	26 Sep 2004 18:49:34 -0000
@@ -913,6 +913,7 @@
    /*
     * Get the entry corresponding to the offset within the section
     */
+   Offset += MemoryArea->Data.SectionData.ViewOffset;
    Entry = MmGetPageEntrySectionSegment(Segment, Offset);
 
    if (Entry == 0)
@@ -3175,12 +3176,12 @@
 
    Address = (PVOID)PAGE_ROUND_DOWN(Address);
 
-   Offset = ((ULONG)Address - (ULONG)MArea->BaseAddress);
+   Offset = ((ULONG_PTR)Address - (ULONG_PTR)MArea->BaseAddress) +
+            MemoryArea->Data.SectionData.ViewOffset;
 
    Section = MArea->Data.SectionData.Section;
    Segment = MArea->Data.SectionData.Segment;
 
-
    PageOp = MmCheckForPageOp(MArea, 0, NULL, Segment, Offset);
 
    while (PageOp)
@@ -3831,7 +3832,7 @@
                                         &SBaseAddress,
                                         SectionSegments[i].Length,
                                         SectionSegments[i].Protection,
-                                        (ULONG_PTR)SectionSegments[i].VirtualAddress,
+                                        0,
                                         FALSE);
             MmUnlockSectionSegment(&SectionSegments[i]);
             if (!NT_SUCCESS(Status))
